#include <avr\io.h>
#include "LCD3310.h"

extern unsigned char font6x8[][6];
static const unsigned char BitTable[8] = {0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};
static LCDControlPortStruct* DevicePort;

static void DeviceSendData(unsigned char Data) {
    unsigned char i = 0;

    DevicePort->CE = 0;
    for(i = 0; i < 8; i++) {
        DevicePort->CLK = 0;
        if((Data & BitTable[i]) == BitTable[i])
            DevicePort->MOSI = 1;
        else
            DevicePort->MOSI = 0;
        DevicePort->CLK = 1;
    }
    DevicePort->CE = 1;
}

static void DeviceOpen(void) {
	DevicePort->CE = 0;
}

static void DeviceClose(void) {
	DevicePort->CE = 1;
}

static void DeviceReset(void) {
	DevicePort->RST = 0;
    DevicePort->RST = 1;
}

///@brief Һ/
///@param data /
///@param command Ϊ1ʱ,Ϊ0ʱ
void LCD_WriteByte(unsigned char data, unsigned char command) {
    DeviceOpen();
    if (command == 0)
		DevicePort->DC = 0;	        // 
    else
        DevicePort->DC = 1;			// 
    DeviceSendData(data);
    DeviceClose();
}

///@brief 趨ҺĶ˿
///@param Port ƶ˿ڵĵַ
///@note ѾҺʼ,ûҪԲٵóʼ
void LCD_SetPort(void* Port) {
	DevicePort = (LCDControlPortStruct*)Port;
	LCD_Init();
}

///@brief ʼҺ
void LCD_Init(void) {
	DeviceReset();

    DeviceClose();
    DeviceOpen();

    LCD_WriteByte(0x21, 0);	// ʹչLCDģʽ
    LCD_WriteByte(0xc8, 0);	// ƫõѹ
    LCD_WriteByte(0x06, 0);	// ¶У
    LCD_WriteByte(0x13, 0);	// 1:48
    LCD_WriteByte(0x20, 0);	// ʹû
    LCD_Clear(0x00);	    // 
    LCD_WriteByte(0x0c, 0);	// 趨ʾģʽʾ

    DeviceClose();
}

///@brief 
///@param Data Դ
void LCD_Clear(unsigned char Data) {
    unsigned int i = 0;

    LCD_WriteByte(0x0C, 0);
    LCD_WriteByte(0x80, 0);

    for(i = 0; i < 504; i++)
        LCD_WriteByte(Data, 1);			
}

///@brief 趨ǰַλ
///@param X 
///@param Y 
void LCD_SetXY(unsigned char X, unsigned char Y) {
    LCD_WriteByte(0x40 | Y, 0);
    LCD_WriteByte(0x80 | X, 0);
}

///@brief ڵǰλдһַ
///@param c ʾַ
void LCD_WriteChar(unsigned char c) {
    unsigned char Line;

    c -= 32;

    for (Line = 0; Line < 6; Line++)
        LCD_WriteByte(font6x8[c][Line], 1);
}

///@brief ڵǰλдһַ
///@param s ַ׵ַ
void LCD_WriteStrings(char *s) {
    while (*s)
        LCD_WriteChar(*s++);
}
